Remove reference to an older script
[phpmyadmin/ammaryasirr.git] / scripts / create-release.sh
blobc6a6cf6e43da96be59cbe6d902f1b221a3019a0c
1 #!/bin/sh
3 # vim: expandtab sw=4 ts=4 sts=4:
6 # More documentation about making a release is available at:
7 # http://wiki.phpmyadmin.net/pma/Devel:Releasing
9 # Fail on undefined variables
10 set -u
11 # Fail on failure
12 set -e
14 KITS="all-languages english"
15 COMPRESSIONS="zip-7z tbz txz tgz 7z"
17 if [ $# -lt 2 ]
18 then
19 echo "Usages:"
20 echo " create-release.sh <version> <from_branch> [--tag]"
21 echo ""
22 echo "If --tag is specified, relase tag is automatically created"
23 echo ""
24 echo "Examples:"
25 echo " create-release.sh 2.9.0-rc1 QA_2_9"
26 echo " create-release.sh 2.9.0 MAINT_2_9_0 --tag"
27 exit 65
31 # Checks whether remote branch has local tracking branch
32 ensure_local_branch() {
33 if ! git branch | grep -q '^..'"$1"'$' ; then
34 git branch --track $1 origin/$1
38 # Marks current head of given branch as head of other branch
39 # Used for STABLE/TESTING tracking
40 mark_as_release() {
41 branch=$1
42 rel_branch=$2
43 echo "* Marking release as $rel_branch"
44 ensure_local_branch $rel_branch
45 git checkout $rel_branch
46 git merge -s recursive -X theirs $branch
49 # Read required parameters
50 version=$1
51 shift
52 branch=$1
53 shift
55 cat <<END
57 Please ensure you have:
58 1. incremented rc count or version in the repository :
59 - in libraries/Config.class.php PMA_Config::__constructor() the line
60 " \$this->set( 'PMA_VERSION', '$version' ); "
61 - in Documentation.html the 2 lines
62 " <title>phpMyAdmin $version - Documentation</title> "
63 " <h1>phpMyAdmin $version Documentation</h1> "
64 - in translators.html
65 - in README
67 Continue (y/n)?
68 END
69 read do_release
71 if [ "$do_release" != 'y' ]; then
72 exit 100
75 # Ensure we have tracking branch
76 ensure_local_branch $branch
78 # Create working copy
79 mkdir -p release
80 workdir=release/phpMyAdmin-$version
81 if [ -d $workdir ] ; then
82 echo "Working directory '$workdir' already exists, please move it out of way"
83 exit 1
85 git clone --local . $workdir
86 cd $workdir
88 # Checkout branch
89 ensure_local_branch $branch
90 git checkout $branch
92 # Check release version
93 if ! grep -q "'PMA_VERSION', '$version'" libraries/Config.class.php ; then
94 echo "There seems to be wrong version in libraries/Config.class.php!"
95 exit 2
97 if ! grep -q "phpMyAdmin $version - Documentation" Documentation.html ; then
98 echo "There seems to be wrong version in Documentation.html"
99 exit 2
101 if ! grep -q "phpMyAdmin $version - Official translators" translators.html ; then
102 echo "There seems to be wrong version in translators.html"
103 exit 2
105 if ! grep -q "Version $version\$" README ; then
106 echo "There seems to be wrong version in README"
107 exit 2
110 # Cleanup release dir
111 LC_ALL=C date -u > RELEASE-DATE-${version}
113 # Building Documentation.txt
114 echo "* Generating Documentation.txt"
115 LC_ALL=C w3m -dump Documentation.html > Documentation.txt
117 # Check for gettext support
118 if [ -d po ] ; then
119 GETTEXT=1
120 else
121 GETTEXT=0
124 # Generate mo files
125 if [ $GETTEXT -eq 1 ] ; then
126 echo "* Generating mo files"
127 ./scripts/generate-mo
128 echo "* Removing gettext source files"
129 rm -rf po
132 if [ -f ./scripts/compress-js ] ; then
133 echo "* Compressing javascript files"
134 ./scripts/compress-js
135 rm -rf sources
138 echo "* Removing unneeded files"
140 # Remove test directory from package to avoid Path disclosure messages
141 # if someone runs /test/wui.php and there are test failures
142 rm -rf test
144 # Remove javascript compiler, no need to ship it
145 rm -rf scripts/google-javascript-compiler/
147 # Remove scripts which are not useful for user
148 for s in compress-js create-release.sh generate-mo mergepo.py php2gettext.sh remove_control_m.sh update-po upload-release ; do
149 rm -f scripts/$s
150 done
152 # Remove git metadata
153 rm -rf .git
154 find . -name .gitignore -print0 | xargs -0 -r rm -f
156 cd ..
158 # Prepare all kits
159 for kit in $KITS ; do
160 # Copy all files
161 name=phpMyAdmin-$version-$kit
162 cp -r phpMyAdmin-$version $name
164 # Cleanup translations
165 cd phpMyAdmin-$version-$kit
166 scripts/lang-cleanup.sh $kit
167 rm -f scripts/lang-cleanup.sh
168 cd ..
170 # Remove tar file possibly left from previous run
171 rm -f $name.tar
173 # Prepare distributions
174 for comp in $COMPRESSIONS ; do
175 case $comp in
176 tbz|tgz|txz)
177 if [ ! -f $name.tar ] ; then
178 echo "* Creating $name.tar"
179 tar cf $name.tar $name
181 if [ $comp = tbz ] ; then
182 echo "* Creating $name.tar.bz2"
183 bzip2 -9k $name.tar
185 if [ $comp = txz ] ; then
186 echo "* Creating $name.tar.xz"
187 xz -9k $name.tar
189 if [ $comp = tgz ] ; then
190 echo "* Creating $name.tar.gz"
191 gzip -9c $name.tar > $name.tar.gz
194 zip)
195 echo "* Creating $name.zip"
196 zip -q -9 -r $name.zip $name
198 zip-7z)
199 echo "* Creating $name.zip"
200 7za a -bd -tzip $name.zip $name > /dev/null
203 echo "* Creating $name.7z"
204 7za a -bd $name.7z $name > /dev/null
207 echo "WARNING: ignoring compression '$comp', not known!"
209 esac
211 # Cleanup
212 rm -f $name.tar
213 done
215 # Remove directory with current dist set
216 rm -rf $name
217 done
219 # Cleanup
220 rm -rf phpMyAdmin-${version}
223 echo ""
224 echo ""
225 echo ""
226 echo "Files:"
227 echo "------"
229 ls -la *.gz *.zip *.bz2 *.7z
231 cd ..
234 if [ $# -gt 0 ] ; then
235 echo
236 echo "Additional tasks:"
237 while [ $# -gt 0 ] ; do
238 param=$1
239 case $1 in
240 --tag)
241 tagname=RELEASE_`echo $version | tr . _ | tr '[:lower:]' '[:upper:]' | tr -d -`
242 echo "* Tagging release as $tagname"
243 git tag -a -m "Released $version" $tagname $branch
244 if echo $version | grep -q '^2\.11\.' ; then
245 echo '* 2.11 branch, no STABLE/TESTING update'
246 else
247 if echo $version | grep '[a-z_-]' ; then
248 mark_as_release $branch TESTING
249 else
250 # We update both branches here
251 # As it does not make sense to have older testing than stable
252 mark_as_release $branch TESTING
253 mark_as_release $branch STABLE
255 git checkout master
257 echo " Dont forget to push tags using: git push --tags"
260 echo "Unknown parameter: $1!"
261 exit 1
262 esac
263 shift
264 done
265 echo
268 cat <<END
271 Todo now:
272 ---------
274 1. If not already done, tag the repository with the new revision number
275 for a plain release or a release candidate:
276 version 2.7.0 gets two tags: RELEASE_2_7_0 and STABLE
277 version 2.7.1-rc1 gets RELEASE_2_7_1RC1 and TESTING
279 2. prepare a release/phpMyAdmin-$version-notes.html explaining in short the goal of
280 this release and paste into it the ChangeLog for this release
281 3. upload the files to SF, you can use scripts/upload-release, eg.:
283 ./scripts/upload-release \$USER $version release
284 4. add SF news item to phpMyAdmin project
285 5. announce release on freshmeat (http://freshmeat.net/projects/phpmyadmin/)
286 6. send a short mail (with list of major changes) to
287 phpmyadmin-devel@lists.sourceforge.net
288 phpmyadmin-news@lists.sourceforge.net
289 phpmyadmin-users@lists.sourceforge.net
291 Don't forget to update the Description section in the announcement,
292 based on Documentation.html.
294 7. increment rc count or version in the repository :
295 - in libraries/Config.class.php PMA_Config::__constructor() the line
296 " \$this->set( 'PMA_VERSION', '2.7.1-dev' ); "
297 - in Documentation.html the 2 lines
298 " <title>phpMyAdmin 2.2.2-rc1 - Documentation</title> "
299 " <h1>phpMyAdmin 2.2.2-rc1 Documentation</h1> "
300 - in translators.html
302 8. add a group for bug tracking this new version, at
303 https://sourceforge.net/tracker/admin/index.php?group_id=23067&atid=377408&add_group=1
305 9. the end :-)